#include <iostream>
#include "C_c.cpp"
#include "fstream"

using namespace std;


long long GetfileSize( char* filePath ){
  long long begin, end;
  ifstream myfile (filePath);
  begin = myfile.tellg();
  myfile.seekg (0, ios::end);
  end = myfile.tellg();
  myfile.close();
  return (end-begin);
}

int main (int argc, char ** argv) {

if (argc < 3 ){
printf("Usage\n Compress a file: ulzw -c source dest\n Decompress a file: ulzw -d source dest\n");
return 0;
}
unsigned char write_buffer[100000];
if ( argv[1][0] == '-' && argv[1][1] == 'c' )
{
ulzw compr;

ifstream file_in;
file_in.open(argv[2],ios::in | ios::binary );
ofstream file_out;
file_out.open(argv[3], ios::out|ios::binary);

int flag = 0;
int chr = 0;
int recv = 0;
long long input_size = GetfileSize(argv[2]);
long long compressed_size = 0;
long long processed_size = 0;
int print_after =0;
cout<<"Compressing "<<argv[2]<<"( "<<input_size<<" bytes)"<<endl<<endl;

while ( (chr = file_in.get()) != -1 )
{
	recv = compr.compress_chr( (unsigned char)chr, write_buffer, flag);
	if ( recv > 0 )
	file_out.write( (char*)write_buffer, recv );
	flag = 1;
	compressed_size+= recv;
	
	if ( print_after == 1024 )
	{
	printf("\r %i % (%ld bytes processed)", processed_size/(input_size/100), processed_size );
	print_after =0;
	}
		processed_size++;
		print_after++;
}
flag = 2;
recv = compr.compress_chr( 0, write_buffer, flag);
if ( recv > 0 )
	file_out.write( (char*)write_buffer, recv );
	compressed_size+= recv;
file_in.close();
file_out.flush();
file_out.close();
printf("\r %i % (%ld bytes processed)", processed_size/(input_size/100), processed_size );
cout<<endl<<"Done!"<<endl;

cout<<endl<<"Compressed size: "<<compressed_size<<" - compression ratio "<<((compressed_size/(input_size/100)))<<" %"<<endl<<endl;
}

if ( argv[1][0] == '-' && argv[1][1] == 'd' )
{
ulzw compr;
int flag = 0;
ifstream file_in2;
ofstream file_out2;
int chr = 0;
int recv = 0;
long long input_size = GetfileSize(argv[2]);
int print_after = 0;

//Decompress test
file_in2.open(argv[2],ios::in | ios::binary );
file_out2.open(argv[3], ios::out|ios::binary);
flag = 0;
long long processed = 0;
long long total_recv = 0;

cout<<endl<<"Decompressing "<<argv[2]<<" ("<<input_size<<" bytes)"<<endl<<endl;

while ( (chr = file_in2.get()) != -1 )
{
processed++;
recv = compr.decompress_chr( (unsigned char)chr, write_buffer, flag);
if ( recv > 0 ){
file_out2.write( (char*)write_buffer, recv );
file_out2.flush();
}
total_recv += recv;


if ( print_after == 1024 ){
printf("\r %i % (received %ld bytes)", processed/(input_size/100), total_recv);
print_after = 0;
}
print_after++;
if ( processed == 1)	
flag = 1;
if ( processed == 2)
flag = 2;
}
file_in2.close();
file_out2.close();

printf("\r %i % (received %ld bytes)", processed/(input_size/100), total_recv);

cout<<endl<<"Done!"<<endl;
}



return 0;
}
